<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close :close-on-click-modal="false" @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px" label-position="left">
			<el-form-item label="姓名" prop="name">
				<el-input v-model="form.name" placeholder="姓名" :disabled="mode == 'audit'" clearable />
			</el-form-item>
			<el-form-item label="手机号码" prop="mobile">
				<el-input v-model="form.mobile" placeholder="手机号码" :disabled="mode == 'audit'" clearable />
			</el-form-item>
			<el-form-item label="用户UID" prop="member_id">
				<el-input v-model="form.member_id" placeholder="用户UID" :disabled="mode == 'audit'" clearable />
			</el-form-item>
			<el-form-item label="状态" prop="status">
				<el-select v-model="form.status" placeholder="请选择">
					<el-option v-for="(item, index) in [{label: '通过', value: 1}, {label: '拒绝', value: 2}]" :key="index" :label="item.label" :value="item.value" />
				</el-select>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSaveing" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '新增等级',
				edit: '编辑等级',
				show: '查看',
				audit: '审核'
			},
			visible: false,
			isSaveing: false,
			//表单数据
			form: { title: '', name: ''},
			//验证规则
			rules: {
			}
		}
	},
	mounted() {
	},
	methods: {
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},
		//表单提交方法
		submit(){
			this.$refs.dialogForm.validate(async (valid) => {
				if (valid) {
					this.isSaveing = true;
					var res = {};
					if(this.mode == 'add'){
						res = await this.$API.member.promoter.add.post(this.form);
					}else if(this.mode == 'edit'){
						res = await this.$API.member.promoter.edit.post(this.form);
					}else if(this.mode == 'audit'){
						res = await this.$API.member.promoter.audit.post(this.form);
					}

					this.isSaveing = false;
					if(res.code == 1){
						this.$emit('success', this.form, this.mode)
						this.visible = false;
						this.$message.success("操作成功")
					}else{
						this.$message.error(res.message)
					}
				}else{
					return false;
				}
			})
		},
		//表单注入数据
		setData(data){
			this.form = data
		}
	}
}
</script>
